package org.jeecg.modules.database.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.database.entity.Component;
import org.jeecg.modules.database.service.IComponentService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import java.util.Arrays;

/**
 * @Description: 元器件
 * @Author: jeecg-boot
 * @Date: 2024-08-30
 * @Version: V1.0
 */
@Tag(name = "元器件")
@RestController
@RequestMapping("/database/component")
@Slf4j
public class ComponentController extends JeecgController<Component, IComponentService> {
    @Autowired
    private IComponentService componentService;

    /**
     * 分页列表查询
     *
     * @param component
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    //@AutoLog(value = "元器件-分页列表查询")
    @Operation(summary = "元器件-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<Component>> queryPageList(Component component,
                                                  @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                  @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                  HttpServletRequest req) {
        QueryWrapper<Component> queryWrapper = QueryGenerator.initQueryWrapper(component, req.getParameterMap());
        Page<Component> page = new Page<Component>(pageNo, pageSize);
        IPage<Component> pageList = componentService.page(page, queryWrapper);
        return Result.OK(pageList);
    }

    /**
     * 添加
     *
     * @param component
     * @return
     */
    @AutoLog(value = "元器件-添加")
    @Operation(summary = "元器件-添加")
    @RequiresPermissions("database:component:add")
    @PostMapping(value = "/add")
    public Result<String> add(@RequestBody Component component) {
        componentService.save(component);
        return Result.OK("添加成功！");
    }

    /**
     * 编辑
     *
     * @param component
     * @return
     */
    @AutoLog(value = "元器件-编辑")
    @Operation(summary = "元器件-编辑")
    @RequiresPermissions("database:component:edit")
    @RequestMapping(value = "/edit", method = {RequestMethod.PUT, RequestMethod.POST})
    public Result<String> edit(@RequestBody Component component) {
        componentService.updateById(component);
        return Result.OK("编辑成功!");
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "元器件-通过id删除")
    @Operation(summary = "元器件-通过id删除")
    @RequiresPermissions("database:component:delete")
    @DeleteMapping(value = "/delete")
    public Result<String> delete(@RequestParam(name = "id", required = true) String id) {
        componentService.removeById(id);
        return Result.OK("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "元器件-批量删除")
    @Operation(summary = "元器件-批量删除")
    @RequiresPermissions("database:component:delete")
    @DeleteMapping(value = "/deleteBatch")
    public Result<String> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        this.componentService.removeByIds(Arrays.asList(ids.split(",")));
        return Result.OK("批量删除成功!");
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    //@AutoLog(value = "元器件-通过id查询")
    @Operation(summary = "元器件-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<Component> queryById(@RequestParam(name = "id", required = true) String id) {
        Component component = componentService.getById(id);
        if (component == null) {
            return Result.error("未找到对应数据");
        }
        return Result.OK(component);
    }

    /**
     * 导出excel
     *
     * @param request
     * @param component
     */

    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, Component component) {
        return super.exportXls(request, component, Component.class, "元器件");
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequiresPermissions("database:component:add")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, Component.class);
    }

}
